#!/bin/sh

# Copyright 2004-2008 Proyecto Brutalix
# Liberado bajo licencia GPL <http://www.gnu.org/licenses/gpl.txt>

if [ -z $1 ] ; then
	echo
	echo No has especificado opciones
	$0 -h 
	exit 1
elif [ -b $1 ] ; then
	echo
	echo No has especificado opciones para el dispositivo $1
	$0 -h
	exit 1
elif [ $1 = -h ] ; then
	echo
        echo "Guarda/Restaura particiones"
        echo uso: particiones.sh [opciones] dispositivo
        echo -h muestra esta ayuda
        echo -s guarda particiones en la cache
        echo -r restaura particiones desde la cache
	echo -sf guarda particiones en fichero
        echo -rf restaura particiones desde fichero

	echo
	exit 0
elif [ -z $2 ] ; then
        echo
        echo No has especidicado dispositivo
        echo
	$0 -h
        exit 1
elif [ ! -b $2 ] ; then
        echo
        echo $2 no existe o no es un dispositivo de bloques
        echo
        exit 1
fi

case "$1" in

	-s)
	if /sbin/sfdisk -d $2 > /brt_cache/particiones.txt ; then echo tabla de particiones guardada correctamente
	else echo No se ha podido guardar la tabla de particiones
	fi
        ;;
	-sf)
	if /sbin/sfdisk -d $2 > particiones.txt ; then echo tabla de particiones guardada correctamente
	else echo No se ha podido guardar la tabla de particiones
	fi
        ;;
        -r)
	if /sbin/sfdisk -f $2 < /brt_cache/particiones.txt ; then echo tabla de particiones restaurada correctamente
	else echo No se ha podido restaurar la tabla de particiones
	fi
        ;;
	-rf)
	if /sbin/sfdisk -f $2 < particiones.txt ; then echo tabla de particiones restaurada correctamente
	else echo No se ha podido restaurar la tabla de particiones
	fi
	;;
	*)
	echo
	echo opcion desconocida
	$0 -h
	exit 1
esac
