'      \|||||/
'       (o o)	    SET PC NAME
'----ooO-(_)-Ooo----------------------------------------------------------------
'
' El script comprueba el nombre del equipo y, si no es el que debera tener,
' lo cambia y reinicia la mquina.
' Def.// Si la IP del equipo es ip1.ip2.ip3.ip4, el *nombre correcto del equipo*
'        ser 'aula-ip3-ip4'.
'
' El script regitra su actividad en el log del sistema.
'
' Requisitos: Windows XP
' 
' author: cesarr@unizar.es
' date: 2007-11-12
'

Option Explicit

' Constantes para el sistema de logging
Const EVENT_SUCCESS 		= 0
Const EVENT_ERROR 			= 1
Const EVENT_WARNING 		= 2
Const EVENT_INFORMATION 	= 4
Const EVENT_AUDIT_SUCCESS 	= 8
Const EVENT_AUDIT_FAILURE 	= 16

' Instanciamos una shell
Dim shell
Set shell = Wscript.CreateObject("Wscript.Shell")

' logging
Dim LogMsg

' Nombre del PC
Dim strPcName
' Instanciamos un objeto WshNetwork
Dim net
Set net = WScript.CreateObject("WScript.Network")
' Obtenemos el nombre
strPcName = net.ComputerName
LogMsg = WScript.ScriptName & " run on " & strPcName & "." & vbNewLine


' Obtenemos la IP del PC
Dim IPAddr
IPAddr = GetIPAddress()

' Componemos el nuevo nombre
Dim nwPcName
Dim arr
arr = split(IPAddr, ".")
nwPcName = "aula-" & arr(2) & "-" & arr(3)

' Comprobamos si el nombre debe cambiarse
If 0 <> strcomp(nwPcName, strPcName, 1) Then
	Call changePcName(nwPcName, strPcName)
Else
	LogMsg = LogMsg & "Old name: " & strPcName & vbNewLine
	LogMsg = LogMsg & "New name: " & nwPcName & vbNewLine
	LogMsg = LogMsg & "No actions taken." & vbNewLine
End If

shell.LogEvent EVENT_INFORMATION, LogMsg
WScript.Quit 0

Sub changePcName(nwPcName, oldPcName)
	Dim objWMIService, colComputers, objComputer
	Dim Result

	Set objWMIService = GetObject( _
	"winmgmts:{impersonationLevel=impersonate,(Shutdown)}!root\cimv2")
	Set colComputers = objWMIService.ExecQuery _
	("SELECT * FROM Win32_ComputerSystem WHERE Name='" & oldPcName & "'")

	For Each objComputer in colComputers
		' WScript.Echo "Renaming " & objComputer.Name & " to " & nwPcName
		Result = objComputer.Rename(nwPcName)
		If Result = 0 Then
			shell.LogEvent EVENT_AUDIT_SUCCESS, WScript.ScriptName & ": " _
			& objComputer.Name & " renamed to " & nwPcName
			' You will want to join the domain or reboot here.
			Dim OS
			Set OS = objWMIService.ExecQuery _
			    ("Select * from Win32_OperatingSystem where Manufacturer='Microsoft Corporation'")
			Dim o
			For Each o in OS
				'Wscript.echo "riniciando..."
				Dim res
				res = o.reboot()
				shell.LogEvent res, WScript.ScriptName & " Rebooting system."
			Next
		Else
			shell.LogEvent EVENT_ERROR, WScript.ScriptName & ": Error renaming " _
			& objComputer.Name & " to " & nwPcName & " (Error " & Result & ")"
		End If
	Next
	'WScript.Echo "Cambiando el nombre a " & nwPcName
End sub

Function GetIPAddress()
	' Intentos
	' El script fallara en el caso de que el sistema todava no haya detectado
	' el hardware de red, por lo que en caso de error reintentaremos la 
	' operacin este nmero de veces.
	Const INTENTOS = 10
	' Tiempo entre intentos (en milisegundos)
	Const RETRY_DELAY = 60000

	Dim objWMIService, IPConfigSet, IPConfig, IPAddr
	
	Dim intento ' contador de intentos
	intento = 0
	Do
		intento = intento + 1
		Set objWMIService = GetObject("winmgmts:\\" & strPcName & "\root\cimv2")
		Set IPConfigSet = objWMIService.ExecQuery _
		    ("Select IPAddress from Win32_NetworkAdapterConfiguration Where IPEnabled=TRUE")
		IPAddr = Null
		LogMsg = LogMsg & "IPAddresses found: " & vbNewLine
		For Each IPConfig in IPConfigSet
		    If Not IsNull(IPConfig.IPAddress) Then 
				Dim i
		        For i=LBound(IPConfig.IPAddress) to UBound(IPConfig.IPAddress)
					Dim ad, st
					ad = IPConfig.IPAddress(i)
					' comprobamos la IP con el ping
					Dim Ping
				    Set Ping = _
						GetObject("winmgmts:{impersonationLevel=impersonate}"). _
				        ExecQuery("select * from Win32_PingStatus where address = '"_
				            & ad & "'")
					st = 0 ' success
					Dim p
				    For Each p in Ping
				        If IsNull(p.StatusCode) or p.StatusCode <> 0 Then 
							st = p.StatusCode
				        End If
				    Next
					LogMsg = LogMsg & ad & "(Status code " & st & ")" _
							 & "{" & intento & " try}" & vbNewLine
					If 0 = st Then
						IPAddr = ad
					End If
		        Next
		    End If
		Next
		Set objWMIService = Nothing
		Set IPConfigSet = Nothing
		Dim wait_and_loop_condition
		wait_and_loop_condition = IsNull(IPAddr) And (intento < INTENTOS)
		If wait_and_loop_condition Then
			WScript.Sleep RETRY_DELAY
		End If
	Loop While wait_and_loop_condition

	If IsNull(IPAddr) Then
		' WScript.Echo "IPAddress not found!"
		LogMsg = LogMsg & "No valid IP address found!"
		shell.LogEvent EVENT_ERROR, LogMsg
		WScript.Quit -1
	End If
	
	GetIPAddress = IPAddr
	
End Function